require("utils")
require("pm")
module(..., package.seeall)
local UART_ID, sendQueue = 1, { }
local uartimeout, recvReady = 500, "UART_RECV_ID"
pm.wake("mcuart")
uart.setup(UART_ID, 19200, 8, uart.PAR_NONE, uart.STOP_1)
uart.on(UART_ID, "receive", function(uid, length)
  table.insert(sendQueue, uart.read(uid, length))
  return sys.timerStart(sys.publish, uartimeout, recvReady)
end)
write = function(s)
  log.info("uartTask.write", s)
  return uart.write(UART_ID, s)
end
return sys.subscribe(recvReady, function()
  do
    local str = table.concat(sendQueue)
    sendQueue = { }
    log.info("uartTask.read length " .. tostring(str:len()) .. "," .. tostring(str:sub(1, 100)) .. "," .. tostring(str:sub(-100, -1)))
    if 1 == str:find(string.char(0x01, 0xf1, 0xff, 0x00)) then
      write(string.char(0x0a, 0x05))
    end
    return str
  end
end)
